"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DcqlQueryResult = void 0;
const v = __importStar(require("valibot"));
const m_dcql_credential_query_js_1 = require("../dcql-query/m-dcql-credential-query.js");
const m_dcql_credential_set_query_js_1 = require("../dcql-query/m-dcql-credential-set-query.js");
const u_dcql_credential_representation_js_1 = require("../u-dcql-credential-representation.js");
const u_dcql_js_1 = require("../u-dcql.js");
var DcqlQueryResult;
(function (DcqlQueryResult) {
    DcqlQueryResult.vW3cCredentialParseOutput = v.object({ claims: u_dcql_js_1.vJsonRecord });
    DcqlQueryResult.vSdJwtCredentialParseOutput = v.object({
        vct: v.string(),
        claims: u_dcql_js_1.vJsonRecord,
    });
    DcqlQueryResult.vMdocCredentialParseOutput = v.object({
        docType: v.string(),
        namespaces: u_dcql_credential_representation_js_1.DcqlMdocRepresentation.vNamespaces,
    });
    const vCredentialParseSuccess = v.object({
        ...u_dcql_js_1.vParseSuccess.entries,
        output: v.union([
            DcqlQueryResult.vW3cCredentialParseOutput,
            DcqlQueryResult.vSdJwtCredentialParseOutput,
            DcqlQueryResult.vMdocCredentialParseOutput,
        ]),
    });
    DcqlQueryResult.vCredentialParseResult = v.union([
        vCredentialParseSuccess,
        u_dcql_js_1.vParseFailure,
    ]);
    DcqlQueryResult.vCredentialQueryResult = v.pipe(v.array(v.array(v.union([v.undefined(), ...DcqlQueryResult.vCredentialParseResult.options]))), (0, u_dcql_js_1.vNonEmptyArray)());
    DcqlQueryResult.vModel = v.object({
        credentials: v.pipe(v.array(m_dcql_credential_query_js_1.DcqlCredentialQuery.vModel), (0, u_dcql_js_1.vNonEmptyArray)(), v.description(`REQUIRED. A non-empty array of Credential Queries that specify the requested Verifiable Credentials.`)),
        credential_matches: v.record(v.pipe(v.string(), v.regex(u_dcql_js_1.idRegex)), v.union([
            v.object({
                ...vCredentialParseSuccess.entries,
                all: v.pipe(v.array(v.array(v.union([v.undefined(), vCredentialParseSuccess, u_dcql_js_1.vParseFailure]))), (0, u_dcql_js_1.vNonEmptyArray)()),
            }),
            v.object({
                ...u_dcql_js_1.vParseFailure.entries,
                all: v.pipe(v.array(v.array(v.union([v.undefined(), vCredentialParseSuccess, u_dcql_js_1.vParseFailure]))), (0, u_dcql_js_1.vNonEmptyArray)()),
            }),
        ])),
        credential_sets: v.optional(v.pipe(v.array(v.object({
            ...m_dcql_credential_set_query_js_1.CredentialSetQuery.vModel.entries,
            matching_options: v.union([
                v.undefined(),
                v.pipe(v.array(v.array(v.string())), (0, u_dcql_js_1.vNonEmptyArray)()),
            ]),
        })), (0, u_dcql_js_1.vNonEmptyArray)(), v.description(`OPTIONAL. A non-empty array of credential set queries that specifies additional constraints on which of the requested Verifiable Credentials to return.`))),
        canBeSatisfied: v.boolean(),
    });
})(DcqlQueryResult || (exports.DcqlQueryResult = DcqlQueryResult = {}));
//# sourceMappingURL=m-dcql-query-result.js.map