"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.vParseResult = exports.vParseFailure = exports.vParseSuccess = exports.vStringToJson = exports.vJsonValue = exports.vJsonRecord = exports.vJson = exports.vJsonArray = exports.vJsonLiteral = exports.vIdString = exports.vNonEmptyArray = exports.vCredentialFormat = exports.idRegex = void 0;
const v = __importStar(require("valibot"));
exports.idRegex = /^[a-zA-Z0-9_-]+$/;
exports.vCredentialFormat = v.picklist([
    'mso_mdoc',
    'vc+sd-jwt',
    'jwt_vc_json',
    'jwt_vc_json-ld',
]);
const vNonEmptyArray = () => {
    return v.custom(input => input.length > 0 ? true : false);
};
exports.vNonEmptyArray = vNonEmptyArray;
exports.vIdString = v.pipe(v.string(), v.regex(exports.idRegex));
exports.vJsonLiteral = v.union([
    v.string(),
    v.number(),
    v.boolean(),
    v.null(),
]);
exports.vJsonArray = v.array(exports.vJsonLiteral);
exports.vJson = v.lazy(() => v.union([exports.vJsonLiteral, v.array(exports.vJson), v.record(v.string(), exports.vJson)]));
exports.vJsonRecord = v.record(v.string(), exports.vJson);
exports.vJsonValue = v.union([exports.vJsonLiteral, exports.vJsonArray, exports.vJsonRecord]);
exports.vStringToJson = v.rawTransform(({ dataset, addIssue, NEVER }) => {
    try {
        return JSON.parse(dataset.value);
    }
    catch (error) {
        addIssue({ message: 'Invalid JSON' });
        return NEVER;
    }
});
exports.vParseSuccess = v.object({
    success: v.literal(true),
    typed: v.literal(true),
    output: v.unknown(),
    issues: v.optional(v.undefined()),
    credential_index: v.number(),
    claim_set_index: v.union([v.number(), v.undefined()]),
});
exports.vParseFailure = v.object({
    success: v.literal(false),
    typed: v.boolean(),
    output: v.unknown(),
    issues: v.pipe(v.array(v.unknown()), (0, exports.vNonEmptyArray)()),
    credential_index: v.number(),
    claim_set_index: v.union([v.number(), v.undefined()]),
});
exports.vParseResult = v.union([exports.vParseSuccess, exports.vParseFailure]);
//# sourceMappingURL=u-dcql.js.map